<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="企微账号" prop="qwUserId">
        <el-select v-model="queryParams.qwUserId" placeholder="企微账号" clearable size="small" @change="updateQwuser()">
          <el-option
            v-for="dict in myQwUserList"
            :key="dict.dictValue"
            :label="dict.dictLabel + '('+dict.corpName+')'"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="客户ID" prop="qwExternalContactId">
        <el-input
          v-model="queryParams.qwExternalContactId"
          placeholder="请输入会员ID"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="会员ID" prop="userId">
        <el-input
          v-model="queryParams.userId"
          placeholder="请输入会员ID"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="会员昵称" prop="nickName">
        <el-input
          v-model="queryParams.nickName"
          placeholder="请输入会员昵称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="企微客户昵称" prop="nickName">
        <el-input
          v-model="queryParams.externalUserName"
          placeholder="请输入企微客户昵称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="课程" prop="courseId">
        <el-select filterable  v-model="queryParams.courseId" placeholder="请选择课程"  clearable size="small" @change="courseChange(queryParams.courseId)">
          <el-option
            v-for="dict in courseLists"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="小节" prop="videoId">
        <el-select filterable  v-model="queryParams.videoId" placeholder="请选择小节"  clearable size="small">
          <el-option
            v-for="dict in videoList"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker v-model="createTime" size="small" style="width: 220px" value-format="yyyy-MM-dd" type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" @change="change"></el-date-picker>
      </el-form-item>
      <el-table-column label="完课时间" align="center" prop="finishTime" />
      <el-table-column label="营期时间" align="center" prop="campPeriodTime" />
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['course:courseWatchLog:myExport']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-tabs type="card" v-model="queryParams.logType" @tab-click="handleClickX">
      <el-tab-pane label="全部" name="10"></el-tab-pane>
      <el-tab-pane v-for="(item,index) in logTypeOptions" :label="item.dictLabel" :name="item.dictValue"></el-tab-pane>
    </el-tabs>
    <el-table border v-loading="loading" :data="courseWatchLogList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="记录编号" align="center" prop="logId" />
      <el-table-column label="企微客户" align="center" prop="externalUserName"/>
      <el-table-column label="会员ID" align="center" prop="userId" />
      <el-table-column label="会员昵称" align="center" prop="fsNickName">
        <template slot-scope="scope">
          <div style="display: flex;white-space: nowrap">
            <div style="margin: auto">
              {{scope.row.fsNickName}}
            </div>
            <el-popover
              placement="right"
              title=""
              trigger="hover">
              <img slot="reference" :src="scope.row.fsAvatar" style="width: 30px;height: 30px">
              <img :src="scope.row.fsAvatar" style="max-width: 200px;max-height: 200px">
            </el-popover>
          </div>
        </template>
      </el-table-column>
      <el-table-column label="课程名称" align="center" prop="courseName" />
      <el-table-column label="小节名称" align="center" prop="videoName" />
      <el-table-column label="记录类型" align="center" prop="logType">
        <template slot-scope="scope">
          <dict-tag :options="logTypeOptions" :value="scope.row.logType"/>
        </template>
      </el-table-column>
      <el-table-column label="播放时长" align="center" prop="duration" />
      <el-table-column label="所属销售" align="center" prop="companyUserName" />
<!--      <el-table-column label="公司名称" align="center" prop="companyName" />-->
      <el-table-column label="企微员工名称" align="center" prop="qwUserName" />
      <el-table-column label="企微账号" align="center" prop="qwUserName" />
<!--      <el-table-column label="所属发送方式" align="center" prop="sendType" />-->
      <el-table-column label="创建时间" align="center" prop="createTime" />
<!--      <el-table-column label="更新时间" align="center" prop="updateTime" />-->
      <el-table-column label="完课时间" align="center" prop="lastHeartbeatTime" />
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

  </div>
</template>

<script>
import {
  myListCourseWatchLog,
  getCourseWatchLog,
  delCourseWatchLog,
  addCourseWatchLog,
  updateCourseWatchLog,
  exportCourseWatchLog,
  exportCourseWatchLogMy
} from "@/api/course/courseWatchLog";
import { courseList,videoList } from '@/api/course/courseRedPacketLog'
import {getMyQwUserList} from "@/api/qw/user";
import {allListTagGroup} from "@/api/qw/tagGroup";
import {listTag} from "@/api/qw/tag";
export default {
  name: "CourseWatchLog",
  data() {
    return {
      createTime:null,
      courseLists:[],
      videoList:[],
      myQwUserList:[],
      logTypeOptions:[],
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 短链课程看课记录表格数据
      courseWatchLogList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        userId: null,
        videoId: null,
        nickName:null,
        logType: "10",
        qwExternalContactId: null,
        externalUserName:null,
        duration: null,
        qwUserId: null,
        companyUserId: null,
        companyId: null,
        courseId: null,
        sTime:null,
        eTime:null,
        scheduleStartTime: null,
        scheduleEndTime: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    courseList().then(response => {
      this.courseLists = response.list;
    });
    this.getList();
    this.getDicts("sys_course_watch_log_type_new").then(response => {
      this.logTypeOptions = response.data;
    });

    getMyQwUserList().then(response => {
      this.myQwUserList = response.data;
    });
  },
  methods: {
    courseChange(row){
      this.queryParams.videoId=null;
      if(row === ''){
        this.videoList=[];
        return
      }
      videoList(row).then(response => {
        this.videoList=response.list
      });
    },
    updateQwuser(){
      for (const user of this.myQwUserList) {
        if (user.dictValue == this.queryParams.qwUserId) {
          this.queryParams.corpId=user.corpId;
          break;
        }
      }
      this.getList();
    },
    change() {
      if (this.createTime != null) {
        this.queryParams.sTime = this.createTime[0];
        this.queryParams.eTime = this.createTime[1];
      } else {
        this.queryParams.sTime = null;
        this.queryParams.eTime = null;
      }
    },

    handleClickX(tab){
      if(tab.name==="10"){
        this.queryParams.logType=null;
      }else{
        this.queryParams.logType=tab.name;
      }
      this.getList()
    },
    /** 查询短链课程看课记录列表 */
    getList() {
      this.loading = true;
      myListCourseWatchLog(this.queryParams).then(response => {
        this.courseWatchLogList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        logId: null,
        userId: null,
        videoId: null,
        logType: null,
        createTime: null,
        updateTime: null,
        qwExternalContactId: null,
        externalUserName:null,
        duration: null,
        qwUserId: null,
        companyUserId: null,
        companyId: null,
        courseId: null,
        scheduleStartTime: null,
        scheduleEndTime: null,
      };
      this.scheduleTime=null;
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.createTime = null;
      this.queryParams.sTime = null;
      this.queryParams.eTime = null;
      this.queryParams.scheduleStartTime = null;
      this.queryParams.scheduleEndTime = null;
      this.scheduleTime=null;
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.logId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加短链课程看课记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const logId = row.logId || this.ids
      getCourseWatchLog(logId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改短链课程看课记录";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.logId != null) {
            updateCourseWatchLog(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addCourseWatchLog(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const logIds = row.logId || this.ids;
      this.$confirm('是否确认删除短链课程看课记录编号为"' + logIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delCourseWatchLog(logIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有短链课程看课记录数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportCourseWatchLogMy(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
